﻿using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Linq;
using System.Windows.Input;
using Microsoft.Practices.Prism.Commands;
using Microsoft.Practices.Prism.Mvvm;

namespace WpfApplication1
{
    public class MainWindowViewModel : BindableBase
    {
        #region Properties

        public ICommand SaveCommand { get; private set; }
        public ICommand TestCommand { get; private set; }

        private ObservableCollection<Car> _carCollection = new ObservableCollection<Car>();
        public ObservableCollection<Car> CarCollection
        {
            get { return _carCollection; }
            set { SetProperty(ref _carCollection, value); }
        }

        private bool _isEnabled = false;
        public bool IsEnabled
        {
            get { return _isEnabled; }
            set { SetProperty(ref _isEnabled, value); }
        }

        private object _activeItem;
        public object ActiveItem
        {
            get { return _activeItem; }
            set { SetProperty(ref _activeItem, value); }
        }

        private ICommand _ResetCommand;
        public ICommand ResetCommand
        {
            get { return _ResetCommand; }
            set { SetProperty(ref _ResetCommand, value); }
        }

        private ICommand _customize;
        public ICommand Customize
        {
            get { return _customize; }
            set { SetProperty(ref _customize, value); }
        }

        #endregion

        public MainWindowViewModel()
        {
            SaveCommand = new DelegateCommand(OnSave);
            CarCollection.CollectionChanged += CarCollection_CollectionChanged;
            init();

        }


        private void init()
        {
            CarCollection.Add(Car.GetCar("BMW", "2017", "Red", 25000   ,   "EXCV       6"));
            CarCollection.Add(Car.GetCar("Ford", "2016", "Blue", 30000,    "LTYUI      892"));
            CarCollection.Add(Car.GetCar("Toyota", "2015", "Yellow", 3000, "BMWERE     7"));
            CarCollection.Add(Car.GetCar("Nissan", "2014", "White", 40000, "BMW RR     7878"));
            CarCollection.Add(Car.GetCar("Lexus", "2013", "Black", 45000 , "ABCDE      2157"));
            CarCollection.Add(Car.GetCar("Lexus", "2007", "Black", 30000 , "Ciort      658"));
        }


        private void OnSave()
        {
            ResetCommand.Execute(null);
        }

        private void CarCollection_CollectionChanged(object sender, NotifyCollectionChangedEventArgs e)
        {
            if (e.OldItems != null)
            {
                foreach (INotifyPropertyChanged oldItem in e.OldItems)
                {
                    oldItem.PropertyChanged -= CollectioItemChanged;
                }
            }

            if (e.NewItems != null)
            {
                foreach (INotifyPropertyChanged newItem in e.NewItems)
                {
                    newItem.PropertyChanged += CollectioItemChanged;
                }
            }
        }

        private void CollectioItemChanged(object sender, PropertyChangedEventArgs e)
        {
            IsEnabled = true;
        }
    }

}

